#import <UIKit/UIKit.h>

@interface HelloController : UITableViewController 
@end

@implementation HelloController

/*
 *  Data source - be aware that Apple has since rejected many applications that read this kind of
 *                data, so you  probably want to make a different choice for your own apps
 */

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView 
{
	return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section 
{
	return [[[NSFileManager defaultManager] directoryContentsAtPath:@"/Applications"] count];
}

- (UITableViewCell *)tableView:(UITableView *)tView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
	UITableViewCell *cell = [tView dequeueReusableCellWithIdentifier:@"any-cell"];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:@"any-cell"] autorelease];
	}

	// Set up the cell
	NSString *appname = [[[NSFileManager defaultManager] directoryContentsAtPath:@"/Applications"] objectAtIndex:[indexPath row]];
	cell.text = appname;

	NSString *imagePath = [NSString stringWithFormat:@"/Applications/%@/icon.png", appname];
	if ([[NSFileManager defaultManager] fileExistsAtPath:imagePath])
		cell.image = [UIImage imageWithContentsOfFile:imagePath];
	else
		cell.image = [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"icon" ofType:@"png" inDirectory:@"/"]];
	return cell;
}

/*
 *  Delegate Methods - This doesn't do anything, plus Apple has removed App launching from the SDK arsenal
 */

 - (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)newIndexPath 
{
	NSString *userSelection = [[[NSFileManager defaultManager] directoryContentsAtPath:@"/Applications"] objectAtIndex:[newIndexPath row]];
	printf("User selected %s\n",  [userSelection UTF8String]);
}

- (void)loadView
{
	[super loadView];
	[self.tableView setRowHeight:64];
}
@end

@interface SampleAppDelegate : NSObject <UIApplicationDelegate> 
{
	UINavigationController *nav;
}
@property (nonatomic, retain)		UINavigationController *nav;
@end

@implementation SampleAppDelegate
@synthesize nav;
- (void)applicationDidFinishLaunching:(UIApplication *)application {	
	UIWindow *window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
	self.nav = [[UINavigationController alloc] initWithRootViewController:[[HelloController alloc] init]];
	[window addSubview:self.nav.view];
	[window makeKeyAndVisible];
}

- (void) dealloc
{
	[self.nav release];
	[super dealloc];
}
@end

int main(int argc, char *argv[])
{
	NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	int retVal = UIApplicationMain(argc, argv, nil, @"SampleAppDelegate");
	[pool release];
	return retVal;
}
